clear
% where are my custom functions?
addpath('../routines');
addpath('../bsp');


% ---   parameters for system size   ---
% parameter to generate system size n=2^k-1
k=menu('Problemgre, Testbeispiele',...
       '   49',...
       '  225',...
       '  961',...
       ' 3969',...
       '16129')+2;
% system size
N=2^k-1;
n=N*N;
% display grids
display_graphics=1;
% show coarsening process
display_coarse=0;
% parameter for anisotropic problem
epsilon=0.01;
% --------------------------------------





nmb=12;
strg=cell(nmb,1);
fun=cell(nmb,1);
strg{ 1}='laplace 2-D ';                                fun{1}='fun2_1';
strg{ 2}='laplace 2-D, alpha=1, beta=100';              fun{2}='fun2_2';
strg{ 3}='laplace 2-D, 1+sin(8pix)^2';                  fun{3}='fun2_3';
strg{ 4}='laplace 2-D, 1+sin(16pix)^2';                 fun{4}='fun2_4';
strg{ 5}='laplace 2-D, 1+sin(32pix)^2';                 fun{5}='fun2_5';
strg{ 6}='laplace 2-D, 1+e^{pix}sin(8pix)^2';           fun{6}='fun2_6';
strg{ 7}='laplace 2-D, 1+e^{2pix}sin(8pix)^2';          fun{7}='fun2_7';
strg{ 8}='laplace 2-D, 1+e^{8pix}sin(8pix)^2';          fun{8}='fun2_8';
strg{ 9}='laplace 2-D, jump. coeff [1,100,1e3,1e4]';    fun{9}='fun2_9';
strg{10}='matrix from the buffer';                     fun{10}='';
strg{11}='-e^2u_{xx}-u_{yy}=f';                        fun{11}='';

strg{nmb}='END';



choice=menu('choice of sample problems',strg);...

if choice<nmb

   fprintf('%s\n',strg{choice});

   if choice<=10
      IsSPD=-1;
   else
      IsSPD=0;
   end % if-else
   
   if nmb~=10
      level=1;
      % list of matrices for any level
      Alist=cell(1,level);
      % projection (prolongation and restriction^T)
      Plist=cell(1,level-1);
      coord=cell(1,level);
      
      % depending on the problem generate initial matrix
      if choice==1
         T=spdiags(ones(N,1)*[-1 2 -1],-1:1,N,N);
         Alist{1}=kron(T,speye(N))+kron(speye(N),T);
      elseif choice==11
         delta=min(1/3,abs(epsilon*log(epsilon)));
         hepsilon=delta/(N+1);
         h=(1-2*delta)/(N+1);
         hy=1/(N+1);
         t=[hepsilon:hepsilon:delta delta+h:h:1-delta 1-delta+hepsilon:hepsilon:1-hepsilon];
         T=spdiags(ones(N,1)*[-1 2 -1],-1:1,N,N);
         Alr=(1/hy^2)*kron(T,speye(N))+(epsilon^2/hepsilon^2)*kron(speye(N),T);
         Ac=(1/hy^2)*kron(T,speye(N))+(epsilon^2/h^2)*kron(speye(N),T);
         % define A within the center and inside the boundary layers
         A=[      Alr      sparse(N^2,2*N^2+2*N);...
                     sparse(N,3*N^2+2*N);...
            sparse(N^2,N^2+N)  Ac  sparse(N^2,N^2+N);...
                     sparse(N,3*N^2+2*N);...
            sparse(N^2,2*N^2+2*N)        Alr];
         % define A on the interface
         A(      N:N:  N^2,     N^2+  1:  N^2+  N)=-(epsilon^2/hepsilon^2)*speye(N);
         A(N^2+2*N:N:2*N^2+N, 2*N^2+N+1:2*N^2+2*N)=-(epsilon^2/h^2)*speye(N);
         A(  N^2+  N+1:N:2*N^2+  N,   N^2+  1:N^2  +  N)=-(epsilon^2/h^2)*speye(N);
         A(2*N^2+2*N+1:N:3*N^2+2*N, 2*N^2+N+1:2*N^2+2*N)=-(epsilon^2/hepsilon^2)*speye(N);
         
         d=epsilon^2*[-2/(hepsilon*(h+hepsilon)) 2/(h*hepsilon) -2/(h*(h+hepsilon))];
         for i=1:N
             A(N^2+i,[i*N  N^2+i  N^2+1+i*N])=d;
         end
         d=epsilon^2*[-2/(h*(h+hepsilon)) 2/(h*hepsilon) -2/(hepsilon*(h+hepsilon))];
         for i=1:N
             A(2*N^2+N+i,[N^2+N+i*N  2*N^2+N+i  2*N^2+N+1+i*N])=d;
         end
         
         d=[-1 2 -1]/hy^2;
         A(N^2+1,[N^2+1  N^2+2])=A(N^2+1,[N^2+1  N^2+2])+d(2:3);
         for i=2:N-1
             A(N^2+i,[N^2+i-1  N^2+i  N^2+i+1])=A(N^2+i,[N^2+i-1  N^2+i  N^2+i+1])+d;
         end
         A(N^2+N,[N^2+N-1  N^2+N])=A(N^2+N,[N^2+N-1  N^2+N])+d(1:2);
         A(2*N^2+N+1,[2*N^2+N+1  2*N^2+N+2])=A(2*N^2+N+1,[2*N^2+N+1  2*N^2+N+2])+d(2:3);
         for i=2:N-1
             A(2*N^2+N+i,[2*N^2+N+i-1  2*N^2+N+i  2*N^2+N+i+1])=A(2*N^2+N+i,[2*N^2+N+i-1  2*N^2+N+i  2*N^2+N+i+1])+d;
         end
         A(2*N^2+N+N,[2*N^2+N+N-1  2*N^2+N+N])=A(2*N^2+N+N,[2*N^2+N+N-1  2*N^2+N+N])+d(1:2);
         Alist{1}=A;
      else
         Alist{1}=lap2d(N,fun{choice}); 
      end % if-else
      
      if choice==11
         xcoord=N*(hepsilon:hepsilon:delta-hepsilon)'*ones(1,N);
         ycoord=ones(N,1)*(1:N);
         coord{1}=[xcoord(:) ycoord(:)];
         
         xcoord=N*delta'*ones(1,N);
         ycoord=ones(1,1)*(1:N);
         coord{1}=[coord{1};...
                   xcoord(:) ycoord(:)];
   
         xcoord=N*(delta+h:h:1-delta-h)'*ones(1,N);
         ycoord=ones(N,1)*(1:N);
         coord{1}=[coord{1};...
                   xcoord(:) ycoord(:)];
   
         xcoord=N*(1-delta)'*ones(1,N);
         ycoord=ones(1,1)*(1:N);
         coord{1}=[coord{1};...
                   xcoord(:) ycoord(:)];
         
         xcoord=N*(1-delta+hepsilon:hepsilon:1-hepsilon)'*ones(1,N);
         ycoord=ones(N,1)*(1:N);
         coord{1}=[coord{1};...
                   xcoord(:) ycoord(:)];
      else
         xcoord=(1:N)'*ones(1,N);
         ycoord=xcoord';
         coord{1}=[xcoord(:) ycoord(:)];
      end
   else
      Alist{1}=Alist{level};
      level=1;
   end

   % --------------   Generation of the multilevel structure   --------------
   level=1;
   if display_graphics
      figure(level);
      clf;
      xmin=min(coord{1}(:,1))-1; xmax=max(coord{1}(:,1))+1;
      ymin=min(coord{1}(:,2))-1; ymax=max(coord{1}(:,2))+1;
      gplot(Alist{level},coord{level},'-r');
      hold on;
      gplot(Alist{level},coord{level},'or');
      hold off;
      axis([xmin xmax ymin ymax]);
      pause(0.00001);
   end % if
   
   n=size(Alist{1},1);
   fprintf('size of the system: %d\n',n);
   fil0=nnz(Alist{1})/size(Alist{1},2);
   nn=size(Alist{level},2);
   flops(0);
   fprintf('level:%2d, size:%6d, fill-in ratio(nnz/n):%4.1f\n',...
           level,nn,nnz(Alist{level})/nn);

   while nn>=10 & nnz(Alist{level})<=10*fil0*nn
         
         % standard damped diagonal smmother
         Dlist{level}=spdiags(1./diag(Alist{level}),0,nn,nn);
         % maximal eigenvalue of preconditioned system
         inrm=1/norm(Dlist{level}*Alist{level},1);
         % ensure that the preconditioned system has maximal eigenvalue 1
         Dlist{level}=inrm*Dlist{level};
         
         % Gauss-Seidel smoother
         GSFlist{level}=tril(Alist{level});
         GSBlist{level}=triu(Alist{level});
         
         if display_graphics
            figure(level+1);
            if display_coarse
               [Plist{level},part]=COARSERS(Alist{level},1/4,coord{level});
            else
               [Plist{level},part]=COARSERS(Alist{level},1/4);
            end % if-else
         else
            [Plist{level},part]=COARSERS(Alist{level},1/4);
         end % if-else
         
         % coarse grid system
         % Galerking-type
         Alist{level+1}=Plist{level}'*Alist{level}*Plist{level};
         coord{level+1}=coord{level}(part,:);
         
         level=level+1;
         if display_graphics
            figure(level);
            clf;
            gplot(Alist{level},coord{level},'-r');
            hold on;
            gplot(Alist{level},coord{level},'or');
            hold off;
            axis([xmin xmax ymin ymax]);
            pause(0.00001);
         end % if
         
         nn=size(Alist{level},2);
         if nn>0
            fprintf('level:%2d, size:%6d, fill-in ratio(nnz/n):%4.1f\n',...
		    level,nn,nnz(Alist{level})/max(nn,1));
         end
   end % for m
   if IsSPD
      Dlist{level}.U=chol(Alist{level});Dlist{level}.L=Dlist{level}.U';
   else
      [Dlist{level}.L,Dlist{level}.U]=lu(Alist{level});
   end % if-else
   GSFlist{level}.L=Dlist{level}.L;
   GSFlist{level}.U=Dlist{level}.U;
   GSBlist{level}.L=Dlist{level}.L;
   GSBlist{level}.U=Dlist{level}.U;
   fprintf('flops for AMG setup %12.4e\n',flops);
   %for m=1:level
   %   fprintf('level:%2d, size:%6d, fill-in ratio(nnz/n):%4.1f\n',...
   %           m,size(Alist{m},2),nnz(Alist{m})/size(Alist{m},2))
   %end % for m
   % ------------   END Generation of the multilevel structure   ------------

   
   % call script file with iteration process
   iteration;
   
end % if choice<3



