function x=Ax2(b)

global i_smoother mu nu Alist Plist Dlist GSFlist GSBlist;



   bs=size(b,2);
   n=size(b,1);
   x=zeros(n,bs);
   
   for i=1:bs
       % auxillary vector r. It contains the residual and after that the 
       % defect 
       r=b(:,i);
   
       % ----------------------- CG iteration loop -----------------------
       % compute norm of the residual
       nrm=norm(r,inf);
       z=zeros(n,1);
       p=zeros(n,1);
       rho=0;
       rho_old=1;
       sigma=1;
       it=0;
       tol=nrm*sqrt(eps);
   
       while nrm>tol
	 
	     it=it+1;
	     
	     % ------------ Solve preconditioned system: Mz=r ------------
	     if i_smoother==1
	        % 1. Damped diagonal smoothing
		z=MGPCall(r,Alist,Plist,Plist,nu,nu,mu,'Smoother',Dlist);
	     elseif i_smoother==2
	        % 2. Gauss-Seidel smoothing (post-smoothing is performed
		% in reverse order, same number of pre- and post-smoothing
		% steps)
		z=MGPCall(r,Alist,Plist,Plist,nu,nu,mu,'SSmoother',GSFlist,'SSmoother',GSBlist);
	     end % if-elseif-else
	     % --------- END Solve preconditioned system: Mz=r ----------
      
	     rho_old=rho;
	     % rho=r'*z
	     rho=r'*z;
	     if it==1
	        p=z;
	     else
	        beta=rho_old\rho;
	        p=z+p*beta;
	     end % if-else it==1
      
	     z=Alist{1}*p;
	     % sigma=p'*A*p
	     sigma=p'*z;
	     alpha=sigma\rho;
	     x(:,i)=x(:,i)+p*alpha;
	     r=r-z*alpha;
	     nrm=norm(r,inf);
             
       end % while nrm>tol
   end % for i

%   [norm(x-Alist{1}\b,1), norm(Alist{1}*x-b,1)]
   