function PREC=SYMSCALE(M,PARAM)
% PREC=SYMSCALE(M)
% PREC=SYMSCALE(M,PARAM)
%
% computes an initial diagonal scaling D for a Hermitian matrix M such that 
% (D*M*D)^2 almost becomes unit diagonal
% 
% -------------------------------------------------------------------------
%
% Input
% -----
% M                 input matrix
% PARAM             structure of additional parameters
% PARAM.type        type of matrix
%                   0   general
%                   1   Hermitian                    \
%                   2   Hermitian, positive definite /  (REQUIRED!)
% -------------------------------------------------------------------------
%
% Output
% ------
% PREC              structure of preconditioning information
% PREC.D            diagonal matrix that consists of inverses of the square
%                   roots of diag(M), i.e. D*M*D has unit diagonal

if nargin==2
   if PARAM.type~=2 & PARAM.type~=1
      error('matrix type must be at least Hermitian');
   end % if
end % if

n=size(M,1);
PREC.D=speye(n);

% ---   later   ---

